#pragma once

#include "Interfaces.h"

#include <boost/python/object.hpp>

/**Classe de gestion des objets python.
La classe prend une rfrence  la construction et la relche  la destruction.*/
class CPyObject{
protected:
	PyObject*m_PyObj;
	explicit CPyObject(PyObject*pyFonct):m_PyObj(NULL){set(pyFonct);}
	~CPyObject(){if(m_PyObj)Py_DECREF(m_PyObj);}
public:
	void set(PyObject*pyFonct){
		if(m_PyObj)
			Py_DECREF(m_PyObj);
		if(pyFonct && pyFonct!=Py_None)
			Py_INCREF(pyFonct);
		m_PyObj=pyFonct;
	}
	bool isNull()const{return m_PyObj==NULL;}
};
/**Classe de gestion d'un fonctor condition pour les tapes*/
class CPyCondFct:public ICondFct,public CPyObject{
	CPyCondFct(CPyCondFct const&);
	CPyCondFct&operator=(CPyCondFct const&);
public:
	explicit CPyCondFct(PyObject*pyFonct=NULL):CPyObject(pyFonct){}
	bool operator()()const override{
		return boost::python::call<bool>(m_PyObj);
	}
};
/**Classe de gestion d'un fonctor condition sur un flottant pour l'analyseur, les squences et les rfrences*/
class CPyCondFctFloat:public ICondFctFloat,public CPyObject{
	CPyCondFctFloat(CPyCondFctFloat const&);
	CPyCondFctFloat&operator=(CPyCondFctFloat const&);
public:
	explicit CPyCondFctFloat(PyObject*pyFonct=NULL):CPyObject(pyFonct){}
	bool operator()(float val)const override{
		return boost::python::call<bool>(m_PyObj,val);
	}
};
